; File:         Char1a.asm
; Author:       RuiLoureiro
; Date:         20 /06 /2005
; Assembled in Quick Editor in Project -> Console Assemble & Link
; 
.486 
.model flat,stdcall 
option casemap:none 
include \masm32\include\windows.inc
;**********************************************************************************************
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc 
include \masm32\include\masm32.inc
; ---------------------------------------------------------------------------------------------
includelib \masm32\lib\kernel32.lib 
includelib \masm32\lib\user32.lib
includelib \masm32\lib\masm32.lib

include \masm32\macros\macros.asm
include \masm32\macros\ucmacros.asm
;-------------------------------------------------------------------------------------------
.data
align 4
                  dd ?                 ; -8 number of records read
                  dd 20                ; -4 number of record structures
_InputBuffer      db 20*20 dup (?)
; 
       dd 4
WSTR  _UniErro, "Erro" 

       dd 24
WSTR  _UniString1, " j s ngremes aces "  ; testar acentos
       dd 24
WSTR  _UniString2, "  j s ngremes ACES"  ; testar acentos
       dd 48
WSTR  _UniString3, "   -           -          "  ; testar acentos

; ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
.data?
_hScreenBuffer    dd ?
_hInputBuffer     dd ?
;----------------------------------------------------------------------------------------------
.code 
; 
start:           call     HndInOutGet    
                 jc       _eStart

                 mov       edx, offset _UniString1 
                 mov       ecx, dword ptr [edx - 4]
                 call      BufferPrint
                 call      KeyOnlyWait                          
                 jc        short _erro                       
                 
                 mov       edx, offset _UniString2
                 mov       ecx, dword ptr [edx - 4]
                 call      BufferPrint
                 call      KeyOnlyWait
                 jc        short _erro

                 mov       edx, offset _UniString3
                 mov       ecx, dword ptr [edx - 4]
                 call      BufferPrint
                 call      KeyOnlyWait
                 jnc       short _sbStart

                 ;
_erro:           mov       edx, offset _UniErro 
                 mov       ecx, dword ptr [edx - 4]
                 call      BufferPrint
                 call      KeyOnlyWait
                 call      KeyOnlyWait
                 ;
                 ; close all
                 ; ---------
_sbStart:	     invoke	  CloseHandle, _hScreenBuffer          ; Close screen buffer
                 invoke   CloseHandle, _hInputBuffer           ; Close input buffer
                 
_eStart:         invoke	  ExitProcess, 0
; ==============================================
;                    *****         PROCEDURES          *****
; 
HndInOutGet       proc  
                  invoke   GetStdHandle, STD_INPUT_HANDLE     
	            cmp      eax, INVALID_HANDLE_VALUE
                  jne      short @F
                  ;
                  stc
                  ret	
                  ;
                  ; This is the SCREEN number 0
                  ; ---------------------------
@@:               mov      _hInputBuffer, eax                     ; input buffer handle
                  ;
                  invoke   GetStdHandle, STD_OUTPUT_HANDLE    
	            cmp      eax, INVALID_HANDLE_VALUE
                  jne      short @F
                  ;
                  invoke   CloseHandle, _hInputBuffer             ; Close input buffer
                  stc
                  ret
                  ; ----------------------
                  ; Get screen buffer info
                  ; ----------------------
@@:               mov      _hScreenBuffer, eax                    ; screen buffer handle
                  clc
                  ret
HndInOutGet       endp                 
; 
; Action:
;        Prints the buffer pointed by EDX.
;
; Input:
;        EDX   - Buffer string pointer
;        ECX   - buffer's length
;
BufferPrint         proc    
                    LOCAL   wNum:DWORD
                    pushad
                    ;
                    or       ecx, ecx
                    jz       short @F
                    
                    push     ecx
                        lea      ebx, wNum
                        invoke   WriteConsoleW, _hScreenBuffer,       ; handle
                                                edx,                  ; print buffer
                                                ecx,                  ; write ECX char
                                                ebx,                  ; Number written
                                                0                     ;
                    pop     ecx
                    ;
                    cmp     eax, 0
                    jne     short @F
                    ;
                    lea     ebx, wNum
                    cmp     ecx, dword ptr [ebx]
                    je      short @F
                    
                    stc
                    popad
                    ret

@@:                 clc
                    popad
                    ret
BufferPrint         endp
; ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Action:
;        Clean the input buffer and wait for a key.
;
; Out:
;       clc: key was pressed -> clean the input buffer -> exit
;
;       stc: error
;
KeyOnlyWait         proc
                    LOCAL    nEvents:DWORD
                    
                    ; ------------------
                    ; Clean input buffer
                    ; ------------------
                    invoke    FlushConsoleInputBuffer, _hInputBuffer
                    
                    ; ----------------------
                    ; Wait for input records
                    ; ----------------------
_iKeyOnlyWait:      invoke    WaitForSingleObject, _hInputBuffer,    ;INFINITE 
                                                   0                 ; returns immediately
                    cmp       eax, WAIT_FAILED
                    jne       short @F
                    ;
                    stc
                    ret
                    ;
@@:                 cmp       eax, WAIT_OBJECT_0
                    jne       short _iKeyOnlyWait                    ; nothing-> return

                    ; --------------------------------------
                    ; Object is signaled -> Number of events
                    ; --------------------------------------
                    invoke    GetNumberOfConsoleInputEvents, _hInputBuffer,
                                                             ADDR nEvents
                    cmp       eax, 0
                    jne       short _KeyOnlyWait0
                    ;
                    stc       ; error
                    ret
                    
                    ; ----------------
                    ; Next input event
                    ; ----------------   
_KeyOnlyWait0:      mov       eax, nEvents
                    cmp       eax, 0
                    je        short _iKeyOnlyWait

                    ; -----------------
                    ; Read input buffer
                    ; -----------------
                    dec       eax
                    mov       nEvents, eax
                    ;
                    invoke    ReadConsoleInputW, _hInputBuffer,          
                                               ADDR _InputBuffer,       
                                               20,                        ; read 1
                                               ADDR _InputBuffer - 8 
                    cmp      eax, 0
                    jne      @F                                          ; not error
                    ;         
                    stc
                    ret
                    
                    ; ----------------------
                    ;     Key pressed ?
                    ; ----------------------
@@:                 push   esi
                    ;
                       mov    esi, offset _InputBuffer
                       xor    ebx, ebx
                       mov    ecx, dword ptr [esi - 8]
                       or     ecx, ecx
                       jnz    short @F
                    ;
_zecx:              pop    esi
                    jz     short _KeyOnlyWait0
                    ;
_inxt:                 dec    ecx
                       jz     short _zecx
                       ;
                       add    ebx, 20                                ; LenInputRecord = 20      
                       ;
@@:                    cmp    word ptr [esi + ebx], KEY_EVENT        ; EventType
                       jne    short _inxt
                       ;
                       cmp    word ptr [esi + ebx + 4], 1            ; Key pressed
                       jne    short _inxt
                    ;
                    pop    esi
                    
                    ; -----------------------------------------------
                    ; KEY was pressed, so Clean input buffer and EXIT
                    ; -----------------------------------------------
                    invoke    FlushConsoleInputBuffer, _hInputBuffer
                    ;
                    clc
                    ret
KeyOnlyWait         endp  
; 
END start

